#-----------------------------------------------------------------------------
#
#   Python translation of tooltests.rb
#
#-----------------------------------------------------------------------------
# Original copyright notice:
#
# Copyright 2005, @Last Software, Inc.
#
# This software is provided as an example of using the Ruby interface
# to SketchUp.
#
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

import tool

class ToolTests(tool.Tool):

	# Called when you select the tool
	#def activate(self):
	#	print "activate called"

	# Called when I select another tool or quit SketchUp
	def deactivate(self, view):
		print "deactivate called"

	# Called when I roll middle mouse button?
	def draw(self,view):
		print "draw called"

	# Called when I bring SketchUp into view. Followed directly by draw
	def getExtents(self):
		print "getExtents called"

	# This is called followed directly by onRButtonDown
	def getMenu(self, menu):
		print "getMenu called"

	# Called when I press the Esc key. Followed directly by onKeyDown
	def onCancel(self, reason, menu):
		print "onCancel called"

	def onKeyDown(self, char, rpt, flags, view):
		print "onKeyDown called"

	def onKeyUp(self, char, rpt, flags, view):
		print "onKeyUp called"

	# NOTE: Called after onLButtonDown and onLButtonUp. 
	def onLButtonDoubleClick(self, flags, x, y, view):
		print "onLButtonDoubleClick called"

	def onLButtonDown(self, flags, x, y, view):
		print "onLButtonDown called"

	def onLButtonUp(self, flags, x, y, view):
		print "onLButtonUp called"

	# Called a lot so I did not put a print message in
	def onMouseEnter(self, view):
		pass

	# Called a lot so I did not put a print message in
	def onMouseLeave(self, view):
		pass

	# Called a lot so I did not put a print message in
	def onMouseMove(self, flags, x, y, view):
		pass

	# NOTE: Called after onrButtonDown and onRButtonUp.
	def onRButtonDoubleClick(self, flags, x, y, view):
		print "onRButtonDoubleClick called"

	def onRButtonDown(self, flags, x, y, view):
		print "onRButtonDown called"

	# Called not only right after a onRButtonDown, but after a onRButtonDoubleClick?
	def onRButtonUp(self, flags, x, y, view):
		print "onRButtonUp called"

	# NOTE: onReturn is followed directly by onKeyDown
	def onReturn(self, view):
		print "onReturn called"
					       
	def onUserText(self, text, view):
		print "onUserText called"

	# Called when I double-click middle mouse button (exits out of orbit)
	def resume(self, view):
		print "resume called"

	# Called when I press middle mouse button (goes into orbit)
	def suspend(self, view):
		print "suspend called"

def tooltests():
	tools = Sketchup.active_model().tools()
	tool = ToolTests()
	Sketchup.active_model().select_tool(tool)

import menus
plug = menus.get_menu("Plugins")
supy = plug.add_submenu("SuPy Tests")
supy.add_item("ToolTests", tooltests)
